<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

//type
import type { UtilityCost } from '@/types/utiliycost/UtilityCost'
import type { UtilityDetail } from '@/types/utiliycost/UtilityDetail'

// store
import { useUtilityStore } from '../../stores/utilitycost/utilitycost'
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

//view
import UtilityNewBill from './UtilityNewBill.vue'
import { useUserStore } from '@/stores/user'
import UCItemDon from './UCItemDon.vue'

const utilityStore = useUtilityStore()
const userStore = useUserStore()
const UCDialog = ref(false)
const divItems = ref<HTMLElement | null>(null)
const sortOrder = ref<'asc' | 'desc'>('asc')
const detailOfBill = ref(true)
const chartCard = ref('Table')

function searchIndex(item: UtilityCost) {
  if ('id' in item) {
    utilityStore.itemIndex = utilityStore.utilityBills.findIndex((bill) => bill.id === item.id)
    console.log('itemIndex:', utilityStore.itemIndex)
    console.log('bill items select', utilityStore.utilityBills[utilityStore.itemIndex])
    console.log('bill items select', utilityStore.utilityBills[utilityStore.itemIndex]?.ucDetails)

    //openDetail Stock Dialog
    detailOfBill.value = true
  }
}

onMounted(() => {
  utilityStore.initUtilityCost.user = userStore.getCurrentUser()
  console.log('utilityStore.utilityBills:', utilityStore.initUtilityCost.user)
  utilityStore.getUtilityBills()
})

function onSubmit() {
  useUtilityStore
}

function formatDate(dateString: any) {
  const date = new Date(dateString)
  return date.toLocaleDateString('th-TH', {
    day: '2-digit',
    month: 'long',
    year: 'numeric'
  })
}
function toggleSortOrderBill(columnKey: keyof UtilityCost) {
  const sortOrderMultiplier = sortOrder.value === 'asc' ? 1 : -1

  utilityStore.utilityBills.sort((a: UtilityCost, b: UtilityCost) => {
    const aValue = a[columnKey]?.toString() ?? ''
    const bValue = b[columnKey]?.toString() ?? ''

    return aValue > bValue ? sortOrderMultiplier : aValue < bValue ? -sortOrderMultiplier : 0
  })

  sortOrder.value = sortOrder.value === 'asc' ? 'desc' : 'asc'
}
function toggleSortOrderItemBill(columnKey: keyof UtilityDetail) {
  const sortOrderMultiplier = sortOrder.value === 'asc' ? 1 : -1

  if (
    utilityStore.itemIndex !== undefined &&
    utilityStore.utilityBills[utilityStore.itemIndex] &&
    utilityStore.utilityBills[utilityStore.itemIndex]!.ucDetails
  ) {
    const currentIndex = utilityStore.itemIndex

    // Sort only if items is not undefined
    utilityStore.utilityBills[currentIndex]!.ucDetails!.sort(
      (a: UtilityDetail, b: UtilityDetail) => {
        const aValue = a[columnKey] ?? ''
        const bValue = b[columnKey] ?? ''

        if (typeof aValue === 'number' && typeof bValue === 'number') {
          // If values are numbers, directly compare them
          return aValue > bValue ? sortOrderMultiplier : aValue < bValue ? -sortOrderMultiplier : 0
        } else {
          // If values are not numbers, convert to strings and compare
          return aValue.toString() > bValue.toString()
            ? sortOrderMultiplier
            : aValue.toString() < bValue.toString()
              ? -sortOrderMultiplier
              : 0
        }
      }
    )
  }

  sortOrder.value = sortOrder.value === 'asc' ? 'desc' : 'asc'
}
</script>

<template>
  <div>
    <v-container>
      <v-laout>
        <v-card border>
          <v-card-title class="text-h5" height="60"> Utility Cost </v-card-title>
          <v-divider class="border-opacity-50" color="c7c3bf" style="padding: 10px"></v-divider>
          <v-container style="width: 100%">
            <v-row class="d-flex justify-center">
              <v-container style="width: 460px; height: 550px; margin-bottom: 20px">
                <v-col cols="12" sm="12" md="12">
                  <v-card>
                    <v-card-title>
                      <v-row>
                        <v-col cols="12" sm="12" md="6"> Bill of Ulity Cost </v-col>
                        <v-col cols="12" class="d-flex justify-end hide-sm" sm="12" md="6">
                          <v-btn @click="utilityStore.newUcDialog = true" size="small">
                            New Invoice
                          </v-btn>
                        </v-col>
                      </v-row>
                    </v-card-title>

                    <v-table fixed-header style="height: 460px; overflow-y: auto">
                      <thead>
                        <tr>
                          <th class="text-left" @click="() => toggleSortOrderBill('id')">ID</th>
                          <th class="text-left">ชื่อพนักงาน</th>
                          <th class="text-left" @click="() => toggleSortOrderBill('creatDate')">
                            วันที่
                          </th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr
                          v-for="(item, index) in utilityStore.utilityBills"
                          :key="index"
                          @click="() => searchIndex(item)"
                        >
                          <td>{{ item.id }}</td>
                          <td>{{ item.user?.name }}</td>
                          <td>{{ formatDate(item.creatDate) }}</td>
                        </tr>
                      </tbody>
                    </v-table>
                  </v-card>
                </v-col>
              </v-container>

              <v-container style="width: 600px; height: 550px; max-height: 900px">
                <v-col cols="12" sm="12" md="12">
                  <v-card>
                    <v-card v-if="detailOfBill == true" style="height: 165px">
                      <v-card-title>รายละเอียดการบันทึก</v-card-title>
                      <v-row style="height: 100px">
                        <v-col
                          cols="3"
                          style="padding-left: 20px; padding-top: 10px; text-align: center"
                        >
                          <v-avatar
                            rounded="0"
                            style="margin-top: 5px; height: 105px; width: 100px"
                          >
                            <v-img
                              :src="
                                'http://localhost:3000/images/users/' +
                                utilityStore.utilityBills[utilityStore.itemIndex]?.user?.image
                              "
                            ></v-img>
                          </v-avatar>
                        </v-col>
                        <v-col cols="9" style="padding-top: 25px; text-align: justify">
                          <v-row no-gutters>
                            <v-col cols="12" md="12" sm="12">
                              <v-card-subtitle>
                                <v-row no-gutters>
                                  <v-col cols="12" md="6" sm="12">
                                    ชื่อพนักงาน :
                                    {{
                                      utilityStore.utilityBills[utilityStore.itemIndex]?.user
                                        ?.name || 'Unknown User'
                                    }}
                                  </v-col>
                                  <v-col cols="12" md="6" sm="12">
                                    วันที่ :
                                    {{
                                      formatDate(
                                        utilityStore.utilityBills[utilityStore.itemIndex]?.creatDate
                                      )
                                    }}
                                  </v-col>
                                </v-row>
                              </v-card-subtitle>
                            </v-col>
                            <v-col cols="12" md="12" sm="12">
                              <v-card-subtitle>
                                <v-row no-gutters>
                                  <v-col cols="12" md="6" sm="12">
                                    จำนวนรายการ :
                                    {{
                                      utilityStore.utilityBills[utilityStore.itemIndex]?.totalItem
                                    }}
                                    รายการ
                                  </v-col>
                                  <v-col cols="12" md="6" sm="12">
                                    รวมเป็นเงิน :
                                    {{
                                      utilityStore.utilityBills[utilityStore.itemIndex]?.totalPrice
                                    }}
                                    บาท
                                  </v-col>
                                </v-row>
                              </v-card-subtitle>
                            </v-col>
                            <v-col cols="12" md="12" sm="12">
                              <v-card-subtitle>
                                รวมเป็นเงิน :
                                {{ utilityStore.utilityBills[utilityStore.itemIndex]?.totalPrice }}
                              </v-card-subtitle>
                            </v-col>
                          </v-row>
                        </v-col>
                      </v-row>
                    </v-card>

                    <v-card>
                      <v-card-title class="text-h5" height="60">
                        <v-row>
                          <v-col cols="12" sm="12" md="6"> ค่าใช้จ่าย </v-col>
                          <v-col cols="12" class="d-flex justify-end hide-sm" sm="12" md="6">
                            <button @click="chartCard = 'Chart'">O</button>
                            <button @click="chartCard = 'Table'">#</button>
                          </v-col>
                        </v-row>
                      </v-card-title>
                      <div v-if="chartCard === 'Table'">
                        <v-table
                          fixed-header
                          style="height: 295px; overflow-y: auto; max-width: 675px"
                        >
                          <thead>
                            <tr>
                              <th class="text-left" @click="() => toggleSortOrderItemBill('id')">
                                ID
                              </th>
                              <th class="text-left" @click="() => toggleSortOrderItemBill('type')">
                                ประเภทค่าใช้จ่าย
                              </th>
                              <th class="text-left" @click="() => toggleSortOrderItemBill('date')">
                                วันที่
                              </th>
                              <th class="text-left" @click="() => toggleSortOrderItemBill('price')">
                                ค่าใช้จ่าย
                              </th>
                            </tr>
                          </thead>
                          <tbody>
                            <template v-if="utilityStore.utilityBills[utilityStore.itemIndex]">
                              <tr
                                v-for="(item, index) in utilityStore.utilityBills[
                                  utilityStore.itemIndex
                                ]?.ucDetails"
                                :key="index"
                              >
                                <td>{{ item.id }}</td>
                                <td>{{ item.type }}</td>
                                <td>{{ formatDate(item.date) }}</td>
                                <td>{{ item.price }}</td>
                              </tr>
                            </template>
                          </tbody>
                        </v-table>
                      </div>
                      <div
                        v-if="chartCard === 'Chart'"
                        style="height: 295px; overflow-y: auto; max-width: 675px"
                      >
                        <UCItemDon></UCItemDon>
                      </div>
                    </v-card>
                  </v-card>
                </v-col>
              </v-container>
            </v-row>
          </v-container>
        </v-card>
      </v-laout>
    </v-container>
  </div>

  <!-- newInv -->
  <UtilityNewBill v-model="utilityStore.newUcDialog"></UtilityNewBill>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table-data {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-card-title {
  background-color: #ab9283;
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
